/******************************************************************************
 * 
 * LDC2 source code
 *
 * $Date: 2007/03/26 01:00:39 $
 * $Author: hachti $
 *
 * $Log: data_block_6.cpp,v $
 * Revision 2.0  2007/03/26 01:00:39  hachti
 * *** empty log message ***
 *
 *
 ******************************************************************************/
 
#include "data_block_6.hh"

/*!
 *\brief Specialisation constructor.
 */
data_block_6::data_block_6(data_block & org)
  :data_block(org)
{
  m_has_known_type=false;
}


/*!
 *\brief Describe the block.
 *\return A vector of text lines describing this block.
 */
vector<string> data_block_6::get_description(){
  vector<string> result;
  result.insert(result.end(),extract_label(3)+"     "+get_typestring()+"Subroutine or Common Block Definition");
  return result;
}

/***************************************************************/
/*!
 *\brief Get exported symbols.
 *\return A vector containing the symbol names exported by this
 *        block.
 */
vector<string> data_block_6::get_exported_symbols(){
  vector<string> result;
  string rs=extract_label(3);
  if (rs!="      ") result.insert(result.end(),rs);
  return result;
}


