/******************************************************************************
 * 
 * LDC2 source code
 *
 * $Date: 2007/03/26 01:00:40 $
 * $Author: hachti $
 *
 * $Log: data_block_7.hh,v $
 * Revision 2.0  2007/03/26 01:00:40  hachti
 * *** empty log message ***
 *
 *
 ******************************************************************************/
 
#ifndef DATA_BLOCK_7_H
#define DATA_BLOCK_7_H

#include <vector>
#include <string>

#include "data_block.hh"

/*!
 *\brief Class for block type (7).
 */
class data_block_7
  : public data_block
{
  friend tape_block * tape_block::gen_from_fd(int,void(*)(void*),
					      void(*)(void*),void*);
protected:
  data_block_7(data_block&);

public:  
  vector<string> get_description();
  vector<string> get_called_symbols();

};

#endif


