/******************************************************************************
 * 
 * LDC2 source code
 *
 * $Date: 2007/03/26 01:00:40 $
 * $Author: hachti $
 *
 * $Log: hw_constants.hh,v $
 * Revision 2.0  2007/03/26 01:00:40  hachti
 * *** empty log message ***
 *
 *
 ******************************************************************************/
 
#ifndef HW_CONSTANTS_H
#define HW_CONSTANTS_H

/* Block start delimiter */
#define BLOCK_START_DELIMITER 0x81  //0201 (SOM:Start of Message)

#define MINIMUM_DATA_BLOCK_WORDSIZE 1

/* Block end delimiters */
#define EOB_LENGTH 2
#define BLOCK_END_DELIMITER_1 0223 // XOFF 0x93
#define BLOCK_END_DELIMITER_2 0xFF

/* End of Tape sequence
 * If EOT_LENGTH is set to 2, EOT_1 becomes insignificant and so on
 */
#define EOT_LENGTH 3
#define EOT_SEQ_1  0x83
#define EOT_SEQ_2  0x93
#define EOT_SEQ_3  0xff

#endif
